if ("undefined" === typeof (clConnector)) {
    var clConnector = {};
    clConnector.isInstall = false;
    clConnector.isStartup = false;
    clConnector.RecordReplayAssist = 0;
    clConnector.RecordReplayAssistOld = 0;
    clConnector.Data = "";
    clConnector.RecordingData = "";
    clConnector.debugOn = true;
    clConnector.sOrg = null;
    clConnector.sPars1 = null;
    clConnector.sPars2 = null;
    clConnector.addToLog = function (typ, txt) {
        if (clConnector.debugOn) {
            console.log("" + Date.now() + ": " + txt);
        }
    };
    clConnector.useNMH = false;
    clConnector.initNMH = function () {
        if (clConnector.useNMH) 
            return;
        clConnector.addToLog(1, "initNMH");
        clConnector.useNMH = true;  
        try {   
            clConnector.clGChostport = chrome.runtime.connectNative("com.clicklearn.clgchost");
            clConnector.clGChostport.onDisconnect.addListener(function () {
                alert("The ClickLearn Chrome Connector uses Native Messaging which requires an application to be registered in the Windows Registry database.\r\nPlease start your ClickLearn Studio application and do the following:\r\n  1. Select the menu Tools-Preferences\r\n  2. Select the tab Troubleshoot\r\n  3. Click on the button Install Chrome Native Messaging Host\r\n  4. Restart your Google Chrome browser.");
                clConnector.useNMH = false;
            });
            clConnector.clGChostport.onMessage.addListener(clConnector.NMHmessage);
            clConnector.addToLog(1, "initNMH send init with id");
            clConnector.clGChostport.postMessage({ msg: "INIT", id: chrome.runtime.id });
        } catch (e) {
            clConnector.addToLog(0, "NMH: " + e.message);
        }
    };
    clConnector.exitNMH = function () {
        if (!clConnector.useNMH)    
            return;
        clConnector.useNMH = false;
        clConnector.clGChostport.onMessage.removeListener(clConnector.NMHmessage);
    };
    clConnector.clGChostport = null;
    // chrome.storage.local.get("clGCNMH", function (sitem) { if (sitem !== null && sitem["clGCNMH"]) clConnector.initNMH(); });
    clConnector.NMHmessage = function (r) {
        try {
            clConnector.addToLog(0, "clgchostmsg: " + r.msg);
            if (r.msg === "fromcls") {
                //chrome.extension.sendRequest({ msg: "updateAll", type: 1, data: "!CL16MI7DV10055942014701137166291455!" }, function (response) { });
                var request = { msg: "updateAll", type: r.typ, data: r.data };
                if (clConnector.sOrg === null) {
                    clConnector.wsCall1(request);
                    return;
                }
                clConnector.RecordingData = "";
                clConnector.addToLog(1, "updateAll-request=" + request.type);
                if (request.type >= 100 && (request.type % 100) === 0) {
                    clConnector.RecordReplayAssistOld = clConnector.RecordReplayAssist;
                    clConnector.addToLog(1, "set old: " + clConnector.RecordReplayAssistOld);
                }
                clConnector.RecordReplayAssist = request.type;
                if (clConnector.RecordReplayAssist === 201) {
                    clConnector.addToLog(1, "reset to old: " + clConnector.RecordReplayAssistOld);
                    clConnector.RecordReplayAssist = clConnector.RecordReplayAssistOld;
                }
                clConnector.Data = request.data;
                clConnector.updateAll();
            }
        } catch (e) {
            clConnector.addToLog(0, "NHMmsgEX:" + e.message);
        }
    };
};  

chrome.runtime.onMessage.addListener(function (msg, sender, sendResponse) {
    try {
        clConnector.addToLog(1, "onmessage=" + msg.text + ", recordreplayassist=" + clConnector.RecordReplayAssist);
        if (msg.text === "clGCconnectorSendMessage") {
            if (msg.id === "frameUpdate") {
                clConnector.updateAll();
                return;
            }
            if (clConnector.RecordReplayAssist === 0) {
                if (msg.id === "find" && clConnector.useNMH) {
                    // TODO: Why is clConnector.RecordReplayAssist not 3 when multiple chrome windows?
                    // clConnector.addToLog(0, "msgid+data=" + msg.id + "," + msg.msg);
                }
                else {
                    return;
                }
            }
            //if (clConnector.RecordReplayAssist == 4) { // inline record
            //    if (msg.id == "mouseclick") {
            //        clConnector.RecordingData += msg.msg + "$$WCLINE$$";
            //        chrome.tabs.captureVisibleTab(null, {}, function (image) {
            //            clConnector.RecordingData += image + "$$WCLINE$$";
            //        });
            //    }
            //    return;
            //} 
            if (msg.id === "mousemove" || msg.id === "mouseclick") {
                if (clConnector.RecordReplayAssist !== 1) {
                    return;
                }   
            }
            if (clConnector.RecordReplayAssist === 2 || clConnector.RecordReplayAssist === 3)
                clConnector.RecordReplayAssist = 0;
            var mData, manifest, emsg;
            if (clConnector.useNMH) {
                try {
                    mData = msg.msg;
                    try {
                        manifest = chrome.runtime.getManifest();
                        mData += "$CLV$" + manifest.version;
                    } catch (e) {
                        emsg = e.message;
                    }
                    try {
                        if (msg.id === "find") {
                            chrome.windows.getCurrent(null, function (cwin) { clConnector.clGChostport.postMessage({ msg: "clGCconnector", id: msg.id, data: mData + "$CLW$" + cwin.left + "," + cwin.top + "," + cwin.width + "," + cwin.height }); });
                        }
                        else {
                            clConnector.clGChostport.postMessage({ msg: "clGCconnector", id: msg.id, data: mData });
                        }
                    } catch (e) {
                        clConnector.clGChostport.postMessage({ msg: "clGCconnector", id: msg.id, data: mData });
                    }
                } catch (e) {
                    clConnector.addToLog(0, "NMHmessage=" + e.message);
                }
            }
            else {
                var xhr = new XMLHttpRequest();
                var result = null;
                try {
                    xhr.open("POST", "http://127.0.0.1:16107?clGCconnector=" + msg.id);
                    mData = msg.msg;
                    try {
                        manifest = chrome.runtime.getManifest();
                        mData += "$CLV$" + manifest.version;
                    } catch (e) {
                        emsg = e.message;
                    }
                    xhr.send(mData);
                } catch (e) {
                    clConnector.addToLog(0, "smessage=" + e.message);
                }
            }
        }
    } catch (e) {
        var emsg2 = e.message;
    }
});

chrome.extension.onRequest.addListener(
    function (request, sender, sendResponse) {
        clConnector.addToLog(1, "onrequest=" + request.msg);
        if (request.msg === "doNMH") {
            if (request.data)
                clConnector.initNMH();
            else
                clConnector.exitNMH();
        }
        else if (request.msg === "updateAll") {
            if (request.type === 4 && clConnector.RecordReplayAssist === 4) {
                clConnector.wsCall("2", clConnector.RecordingData);
                clConnector.RecordReplayAssist = 0;
                return;
            }
            if (clConnector.sOrg === null) {
                clConnector.wsCall1(request);
                return;
            }
            clConnector.RecordingData = "";
            clConnector.addToLog(1, "updateAll-request=" + request.type);
            clConnector.RecordReplayAssist = request.type;
            clConnector.Data = request.data;
            sendResponse({ value: clConnector.updateAll() });
        }
    }
);

chrome.tabs.onUpdated.addListener(function (tabId, changeInfo, tab) {
    clConnector.addToLog(1, "onupdate=" + tabId + " , " + tab.url);
    //clConnector.addToLog(1, "winid=" + tab.windowId)
    //chrome.windows.getCurrent(null, function (w) { console.log(w); });
    clConnector.updateAll();
});

clConnector.updateAll = function () {
    //chrome.tabs.getAllInWindow(null, function (tabs) { tabs.forEach(function (tab) { clConnector.loader(tab); }); });
    chrome.tabs.query({}, function (tabs) { tabs.forEach(function (tab) { clConnector.loader(tab); }); });
    return (true);
}   

clConnector.wsCall1 = function (request) {
    clConnector.addToLog(1, "wsCall1 started");
    clConnector.sPars1 = request.type;
    clConnector.sPars2 = request.data;
    chrome.storage.local.get(["clConnectorWCt", "clConnectorWCs"], clConnector.wsCall1a);
}

clConnector.wsCall1a = function (sitem) {
    clConnector.addToLog(1, "wsCall1a started");
    if (sitem !== null && typeof (sitem["clConnectorWCs"]) !== "undefined" && sitem["clConnectorWCs"] !== null && sitem["clConnectorWCs"] !== "") {
        clConnector.addToLog(1, "CLICKLEARN CONNECTOR TAKEN FROM LOCAL STORAGE!");
        clConnector.sOrg = sitem["clConnectorWCs"];
        clConnector.RecordReplayAssist = clConnector.sPars1;        
        clConnector.Data = clConnector.sPars2;
        if (typeof (sitem["clConnectorWCt"]) !== "undefined" && sitem["clConnectorWCt"] !== null) {
            var stim = sitem["clConnectorWCt"];
            var ntim = (new Date()).getTime();
            clConnector.addToLog(1, "...stim=" + stim + ",ntim=" + ntim + ".");
            var one_day = 1000 * 60 * 60 * 24;
            if (ntim - stim <= 0 || (ntim - stim) / one_day > 7) {
                clConnector.addToLog(1, "CLICKLEARN CONNECTOR WILL AUTOMATICALLY BE RE-LOADED THE NEXT TIME THE BROWSER IS LOADED!");
                chrome.storage.local.remove(["clConnectorWCt", "clConnectorWCs"], function () { });
            }
        }
        clConnector.updateAll();
    }
    else {
        clConnector.wsCall("1", { type: clConnector.sPars1, data: clConnector.sPars2 });
    }
}

clConnector.wsCall = function (request, data) {
    var s = "";
    var err = "";
    var req = null;
    try {
        req = new XMLHttpRequest();
        var realReq;
        realReq = "https://services.clicklearn.dk/ClickLearnWebService.asmx/WebConnector";
        var dataStr = data.data;
        clConnector.addToLog(1, "dataStr1=" + dataStr);
        var dp = data.data.split("!");
        if (dp.length >= 3) {
            realReq = dp[2];
            dataStr = dp[0] + "!" + dp[1] + "!";
            if (dp.length >= 3) {
                dp.shift();
                dp.shift();
                dp.shift();
                dataStr += "!" + dp.join("!", 3);
            }
        }
        clConnector.addToLog(1, "dataStr2=" + dataStr);
        if (clConnector.debugOn) {
            realReq = "http://localhost:2342/ClickLearnWebService.asmx/WebConnector";
        }
        clConnector.addToLog(1, "wsCallreq=" + realReq);
        if (request === "1") {
            chrome.storage.local.set({ "clConnectorWCu": realReq }, function () { });
            realReq += "?Request=" + request + dataStr + "&d=" + (new Date()).toString();
            clConnector.addToLog(1, "wsCallreq2=" + realReq);
            req.onreadystatechange = function (e) {
                clConnector.addToLog(1, "onready=" + req.readyState);
                if (req.readyState === 4) {
                    var err = "Cannot communicate with ClickLearn Cloud. Please make sure that you can access https://services.clicklearn.dk and it is trusted.";
                    var s = null;
                    try {
                        if (req.responseType === "" || req.responseType === "text") {
                            s = req.response;
                            if (s.indexOf("<?xml") === 0) {
                                s = req.responseXML.documentElement.textContent;
                            }
                        }
                        else {
                            s = req.responseXML.documentElement.textContent;
                        }
                    } catch (e) {
                        err += "\r\n" + e.message;
                        clConnector.addToLog(0, "wsCallException1=" + err);
                        alert(err);
                    }
                    if (request === "1") {
                        clConnector.sOrg = s === null ? "" : s;
                        if (s !== null && s !== "") {
                            var tim = (new Date()).getTime();
                            chrome.storage.local.set({ "clConnectorWCt": tim }, function () { });
                            chrome.storage.local.set({ "clConnectorWCs": s }, function () { });
                        }
                        clConnector.RecordReplayAssist = data.type;
                        clConnector.Data = dataStr;
                        clConnector.updateAll();
                    }
                }
            }
            req.open('GET', realReq, true);
        }
        else {
            realReq += "?Request=" + request + "&d=" + (new Date()).toString();
            req.open('POST', realReq, true);
            req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        }
        clConnector.addToLog(1, "wsCallreq2");
        if (data === null) {
            req.send();
        }
        else {
            req.send("Request=" + request + "&data=" + encodeURIComponent(data));
        }
        clConnector.addToLog(1, "wsCallreq3");
        //try {
        //    s = req.responseXML.documentElement.textContent;
        //} catch (e) {
        //    clConnector.addToLog(0, "wsCallException1=" + e.message);
        //    if (err == "" && req != null && typeof (req.status) != 'undefined')
        //        err = "Error: " + req.status;
        //}
        //clConnector.addToLog(2, "wsCalls=" + s);
    } catch (e) {
        clConnector.addToLog(0, "wsCallException2=" + e.message);
        s = "";
        if (typeof (req.status) !== 'undefined')
            err += " Error: " + req.status;
    }
    clConnector.addToLog(1, "wsCallerr=" + err);
    return ({ value: s, err: err });
}

clConnector.loader = function (tab) {
    if (clConnector.RecordReplayAssist >= 1) {
        clConnector.addToLog(1, "loader-id=" + tab.id);
        clConnector.addToLog(1, "loader-url=" + tab.url);
        chrome.tabs.sendMessage(tab.id, { text: 'clGCextension', type: clConnector.RecordReplayAssist, data: clConnector.Data, sorg: clConnector.sOrg }, function (response) {
            if (chrome.runtime.lastError)
                return;
            clConnector.addToLog(1, "responseA=" + response);
        });
    }
}       

clConnector.initNMH();
